<?php
require_once ('core/config.php');


if (!isset($_SESSION['logistics']['logged_in']) || !isset($_SESSION['logistics']['username']) || !isset($_SESSION['logistics']['password'])) {
    
    // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
    header("location: login.php");
    exit;
} else {    
    $user_data = $User->is_login_valid($_SESSION['logistics']['username'], $_SESSION['logistics']['password']);    
    if ($user_data === false) {
        // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
        header("location: login.php");
        exit;
    }
}

$user_id        = $user_data['user_id'];

// ADD
if (isset($_POST['submit']) && $_POST['submit'] == 'ADD' && $CSRF->check_valid('post')) {
    
    $sender         = trim($_POST['sender']);
    $receiver       = trim($_POST['receiver']);
	$receiver_phone = trim($_POST['receiver_phone']);
	$receiver_email = trim($_POST['receiver_email']);
    $description    = trim($_POST['desc']);
    $origin         = trim($_POST['origin']);
    $destination    = trim($_POST['dest']);
    $date_time      = trim($_POST['datetime']);
	$exp_datetime	= trim($_POST['exp_datetime']);
    $status         = "Shipment Accepted";
           
    if (empty($sender) || empty($receiver) || empty($receiver_phone) || empty($receiver_email) || empty($description) || empty($origin) || empty($destination) || empty($date_time)) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Something is missing! All form fields (*) is required.'); </script>";
        
    } else {
        
        //function to generate a 10-digits tracking code, checks validity during generation
        function generate_tracking_code()
        {
            global $Transaction;
            $tc = mt_rand((int)1000000000, (int)9999999999);
            if ($Transaction->track_cargo($tc) === false) {
                return $tc;
            } else {
                return generate_tracking_code();
            }        
        }
        $tracking_code = generate_tracking_code();
        //Add the cargo record
        $cargo_id = $Transaction->add_cargo($user_id, $tracking_code, $description, $sender, $receiver, $receiver_phone, $receiver_email, $origin, $destination, $status, $date_time, $exp_datetime);
        
        if (is_int($cargo_id) && $cargo_id !== false) {
            
            //if Added successfully then add a cargo history record
            $Transaction->add_cargo_history($cargo_id, $status, $origin, $date_time);
            
            $error = false;
            echo "<script type='text/javascript'> alert('Shipment/Cargo added successfully.'); </script>";
			echo '<meta http-equiv="refresh" content="0; url=index.php" />';
            echo '<script type="text/javascript"> window.top.location = "index.php"; </script>';            
			exit;
                
        } else {                
                
            $error = true;
            echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
        }              
    }      
}

// UPDATE CHECK and FORM DISPLAY
if (isset($_GET['upd']) && $Transaction->get_cargo($_GET['upd']) !== false && $CSRF->check_valid('get')) {
    
    $display_update_form = true;
    $update_cargo_data = $Transaction->get_cargo($_GET['upd']);
          
} else {
    $display_update_form = false;
}

// UPDATE
if (isset($_POST['submit']) && $_POST['submit'] == 'UPDATE' && $CSRF->check_valid('post')) {
    
    $cargo_id       = (int) trim($_POST['cargo_id']);
    $sender         = trim($_POST['sender']);
    $receiver       = trim($_POST['receiver']);
	$receiver_phone = trim($_POST['receiver_phone']);
	$receiver_email = trim($_POST['receiver_email']);
    $description    = trim($_POST['desc']);
    $origin         = trim($_POST['origin']);
    $destination    = trim($_POST['dest']);
    $date_time      = trim($_POST['datetime']);
	$exp_datetime	= trim($_POST['exp_datetime']);
    $status         = trim($_POST['status']);
           
    if (empty($cargo_id) || empty($sender) || empty($receiver) || empty($receiver_phone) || empty($receiver_email) || empty($description) || empty($origin) || empty($destination) || empty($status) || empty($date_time)) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Something is missing! All form fields (*) is required.'); </script>";
        
    } else {
        
        if ($Transaction->get_cargo($cargo_id) !== false) {
            
            //Update cargo records
            $Transaction->update_cargo_field($cargo_id, 'sender', $sender);
            $Transaction->update_cargo_field($cargo_id, 'receiver', $receiver);
            $Transaction->update_cargo_field($cargo_id, 'receiver_phone', $receiver_phone);
            $Transaction->update_cargo_field($cargo_id, 'receiver_email', $receiver_email);
            $Transaction->update_cargo_field($cargo_id, 'description', $description);
            $Transaction->update_cargo_field($cargo_id, 'origin', $origin);
            $Transaction->update_cargo_field($cargo_id, 'destination', $destination);
            $Transaction->update_cargo_field($cargo_id, 'date_added', $date_time);
            $Transaction->update_cargo_field($cargo_id, 'status', $status);
			if (!empty($exp_datetime)) {
				$Transaction->update_cargo_field($cargo_id, 'expected_delivery_date', $exp_datetime);
			} else {
				$Transaction->update_cargo_field($cargo_id, 'expected_delivery_date', null);
			}
			
			//reload form values with updated records
            $update_cargo_data = $Transaction->get_cargo($cargo_id);
			
			if ($status == "Shipment Held")
			{
				if (!empty($update_cargo_data['expected_delivery_date'])) {
					$exp_dt_tm 	= strtotime($update_cargo_data['expected_delivery_date']);
					$nw 		= time();
					$nw_dt		= date('Y-m-d G:i:s', $nw);
					if ($exp_dt_tm > $nw) {
						
						$dt_diff = $exp_dt_tm - $nw;
						$day = floor($dt_diff / 86400);
						$hr  = floor(($dt_diff % 86400) / 3600);
						$min = floor(($dt_diff % 3600) / 60);
						$sec = ($dt_diff % 60);
						$exp_h_dt_text = "<span>$day</span><small class=\"text-muted\">days</small> ";
						$exp_h_dt_text .= "<span>$hr</span><small class=\"text-muted\">hrs</small> ";
						$exp_h_dt_text .= "<span>$min</span><small class=\"text-muted\">mins</small> ";
						$exp_h_dt_text .= "<span>$sec</span><small class=\"text-muted\">secs</small> ";
						$Transaction->update_cargo_field($update_cargo_data['cargo_id'], 'expected_delivery_held_date_text', $exp_h_dt_text);
						$Transaction->update_cargo_field($update_cargo_data['cargo_id'], 'expected_delivery_held_date', $nw_dt);
					}
				}
			} else {
				$nw	= time();
				$exp_dt_tm = strtotime($update_cargo_data['expected_delivery_date']);
				$exp_h_dt_tm = strtotime($update_cargo_data['expected_delivery_held_date']);
				if (!empty($update_cargo_data['expected_delivery_date']) && !empty($update_cargo_data['expected_delivery_held_date']) && $exp_dt_tm > $exp_h_dt_tm) {
					$dt_diff 		= $exp_dt_tm - $exp_h_dt_tm;
					$new_exp_dt_tm 	= $nw + $dt_diff;
					$new_exp_dt		= date('Y-m-d G:i:s', $new_exp_dt_tm);			
					$Transaction->update_cargo_field($update_cargo_data['cargo_id'], 'expected_delivery_date', $new_exp_dt);
				}				
				$Transaction->update_cargo_field($update_cargo_data['cargo_id'], 'expected_delivery_held_date', null);
				$Transaction->update_cargo_field($update_cargo_data['cargo_id'], 'expected_delivery_held_date_text', null);
			}	
            
            $error = false;
            echo "<script type='text/javascript'> alert('Shipment/Cargo updated successfully.'); </script>";
			echo '<meta http-equiv="refresh" content="0; url=index.php" />';
            echo '<script type="text/javascript"> window.top.location = "index.php"; </script>';            
			exit;
					
                
        } else {                
                
            $error = true;
            echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
        }              
    }      
}






?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <meta name="robots" content="index" />
    <meta name="googlebot" content="index" />
    <meta name="robots" content="follow" />
    <meta name="robots" content="nocache" /> 
    <meta http-equiv="cache-control" content="no-cache" />                       
	<meta http-equiv="expires" content="-1" />
    
    <base href="" />
    
    <title>Dashboard | <?php echo $config['app_name'];?></title>


    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet" />

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>
  <body>
  
    <div id="header">
        <?php require_once ('_header.php'); ?>  
    </div>
    
    <div id="content" class="container">
        
        <div class="row">
            <?php require_once ('_main_top.php'); ?>          
        </div>
        
        <div class="row">
            <div class="col-md-2" id="sidebar">
                <?php require_once ('_sidebar.php'); ?>
            </div>
            
            
            <div class="col-md-10">
                
                <?php if ($display_update_form === false) {?>
                
                    <h3 class="page_label">Add Shipment/Cargo</h3>
                    <hr />          
                    
                    <form class="form-horizontal" method="post" action="" onsubmit="return confirm('CONFIRMATION: \n\n Are you sure the information you entered is correct?');">
                        <?php $CSRF->echo_token_input_field(); ?>
                        <div class="form-group">
                            <label for="sender" class="col-sm-3 control-label">Sender: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="sender" name="sender" placeholder="Sender" value="<?php if ($error === true && isset($_POST['sender'])) { echo trim($_POST['sender']);} ?>" maxlength="50" required>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="receiver" class="col-sm-3 control-label">Receiver: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="receiver" name="receiver" placeholder="Receiver" value="<?php if ($error === true && isset($_POST['receiver'])) { echo trim($_POST['receiver']);} ?>" maxlength="50" required>
                            </div>
                        </div>       
						<div class="form-group">
                            <label for="receiver_phone" class="col-sm-3 control-label">Receiver Phone: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="receiver_phone" name="receiver_phone" placeholder="Receiver Phone Number" value="<?php if ($error === true && isset($_POST['receiver_phone'])) { echo trim($_POST['receiver_phone']);} ?>" maxlength="50" required>
							  <small class="help-block">Internation format e.g +447106534443.</small>
                            </div>                            
                        </div>  
						<div class="form-group">
                            <label for="receiver_email" class="col-sm-3 control-label">Receiver Email: *</label>
                            <div class="col-sm-4">
                              <input type="email" class="form-control" id="receiver_email" name="receiver_email" placeholder="Receiver Email" value="<?php if ($error === true && isset($_POST['receiver_email'])) { echo trim($_POST['receiver_email']);} ?>" maxlength="250" required>
                            </div>                            
                        </div>
                        <div class="form-group">
                            <label for="desc" class="col-sm-3 control-label">Shipment Description: *</label>
                            <div class="col-sm-4">
                              <textarea class="form-control" id="desc" name="desc" placeholder="Shipment/Cargo Description" maxlength="250" required><?php if ($error === true && isset($_POST['desc'])) { echo trim($_POST['desc']);}?></textarea>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="origin" class="col-sm-3 control-label">Origin Location: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="origin" name="origin" placeholder="Origin Location" value="<?php if ($error === true && isset($_POST['origin'])) { echo trim($_POST['origin']);} ?>"  required>
                            </div>
                        </div>
                        
                        <div class="form-group">
                            <label for="dest" class="col-sm-3 control-label">Destination Location: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="dest" name="dest" placeholder="Destination Location" value="<?php if ($error === true && isset($_POST['dest'])) { echo trim($_POST['dest']);} ?>" required>
                            </div>
                        </div>
                        
                        <div class="form-group">
                            <label for="datetime" class="col-sm-3 control-label">Date/Time: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="datetime" name="datetime" placeholder="YYYY-MM-DD HH:MM:SS" value="<?php if ($error === true && isset($_POST['datetime'])) { echo trim($_POST['datetime']);} else { echo date('Y-m-d G:i:s'); } ?>" required>
                            </div>
                        </div>
                        
						<div class="form-group">
                            <label for="exp_datetime" class="col-sm-3 control-label">Expected Delivery Date/Time: </label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="exp_datetime" name="exp_datetime" placeholder="YYYY-MM-DD HH:MM:SS" value="<?php echo (($error === true && isset($_POST['exp_datetime']))) ? trim($_POST['exp_datetime']) : ''; ?>" >
							  <span class="help-block"> <b>Optional!</b> If a date/time is specified, this will display a CountDown Timer on the tracking page and pause time
									when shipment history status is set to Shipment HELD</span>
                            </div>
                        </div>
                        
                        <hr class="" />
                        
                        <div class="form-group">
                            <div class="col-sm-7" style="text-align: right;">
                              <button type="reset" id="submit" name="submit" class="btn" >RESET</button>
                              <button type="submit" id="submit" name="submit" value="ADD" class="btn btn-primary submit_btn">ADD SHIPMENT/CARGO</button>
                            </div>
                        </div>
                    </form>
                    
                <?php } else { ?>
                
                    <h3 class="page_label">Update Shipment/Cargo with Tracking Code: <strong><?php echo $update_cargo_data['tracking_code'];?></strong></h3>
                    <hr />          
                    
                    <form class="form-horizontal" method="post" action="" onsubmit="return confirm('CONFIRMATION: \n\n Are you sure the information you entered is correct?');">
                        <?php $CSRF->echo_token_input_field(); ?>
                        <input type="hidden" name="cargo_id" value="<?php echo $update_cargo_data['cargo_id'];?>" />
                        
                        <div class="form-group">
                            <label for="sender" class="col-sm-3 control-label">Sender: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="sender" name="sender" placeholder="Sender" value="<?php echo ($error === true && isset($_POST['sender'])) ? trim($_POST['sender']) : $update_cargo_data['sender'];?>" maxlength="50" required>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="receiver" class="col-sm-3 control-label">Receiver: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="receiver" name="receiver" placeholder="Receiver" value="<?php echo ($error === true && isset($_POST['receiver'])) ? trim($_POST['receiver']) : $update_cargo_data['receiver'];?>" maxlength="50" required>
                            </div>
                        </div>                 
						<div class="form-group">
                            <label for="receiver_phone" class="col-sm-3 control-label">Receiver Phone: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="receiver_phone" name="receiver_phone" placeholder="Receiver Phone Number" value="<?php echo ($error === true && isset($_POST['receiver_phone'])) ? trim($_POST['receiver_phone']) : $update_cargo_data['receiver_phone'];?>" maxlength="50" required>
							  <small class="help-block">Internation format e.g +447106534443.</small>
                            </div>                            
                        </div>
						<div class="form-group">
                            <label for="receiver_email" class="col-sm-3 control-label">Receiver Email: *</label>
                            <div class="col-sm-4">
                              <input type="email" class="form-control" id="receiver_email" name="receiver_email" placeholder="Receiver Email" value="<?php echo ($error === true && isset($_POST['receiver_email'])) ? trim($_POST['receiver_email']) : $update_cargo_data['receiver_email'];?>" maxlength="250" required>
                            </div>                            
                        </div>  
                        <div class="form-group">
                            <label for="desc" class="col-sm-3 control-label">Shipment Description: *</label>
                            <div class="col-sm-4">
                              <textarea class="form-control" id="desc" name="desc" placeholder="Shipment/Cargo Description" maxlength="250" required><?php echo ($error === true && isset($_POST['desc'])) ? trim($_POST['desc']) : $update_cargo_data['description'];?></textarea>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="origin" class="col-sm-3 control-label">Origin Location: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="origin" name="origin" placeholder="Origin Location" value="<?php echo ($error === true && isset($_POST['origin'])) ? trim($_POST['origin']) : $update_cargo_data['origin'];?>" required>
                            </div>
                        </div>
                        
                        <div class="form-group">
                            <label for="dest" class="col-sm-3 control-label">Destination Location: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="dest" name="dest" placeholder="Destination Location" value="<?php echo ($error === true && isset($_POST['dest'])) ? trim($_POST['dest']) : $update_cargo_data['destination'];?>" required>
                            </div>
                        </div>
                        
                        <div class="form-group">
                            <label for="datetime" class="col-sm-3 control-label">Date/Time: *</label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="datetime" name="datetime" placeholder="YYYY-MM-DD HH:MM:SS" value="<?php echo ($error === true && isset($_POST['datetime'])) ? trim($_POST['datetime']) : $update_cargo_data['date_added'];?>" required>
                            </div>
                        </div>
						
						<div class="form-group">
                            <label for="exp_datetime" class="col-sm-3 control-label">Expected Delivery Date/Time: </label>
                            <div class="col-sm-4">
                              <input type="text" class="form-control" id="exp_datetime" name="exp_datetime" placeholder="YYYY-MM-DD HH:MM:SS" value="<?php echo ($error === true && isset($_POST['exp_datetime'])) ? trim($_POST['exp_datetime']) : $update_cargo_data['expected_delivery_date'];?>" >
							  <span class="help-block"> <b>Optional!</b> If a date/time is specified, this will display a CountDown Timer on the tracking page and pause time
									when shipment history status is set to Shipment HELD</span>
                            </div>
                        </div>
                        
                        <div class="form-group">
                            <label for="status" class="col-sm-3 control-label">Change Shipment Status to: *</label>
                            <div class="col-sm-4">
                              <select class="form-control" id="status" name="status" placeholder="Shipment Status" required>
                                <?php
                                    if (isset($config['app_cargo_status']) && is_array($config['app_cargo_status'])) {
                                        foreach ($config['app_cargo_status'] as $cargo_status) {
                                            
                                            $selected_status = ($error === true && isset($_POST['status'])) ? trim($_POST['status']) : $update_cargo_data['status'];
                                            
                                            if ($selected_status == $cargo_status) {
                                                echo "<option value=\"$cargo_status\" selected=\"selected\">$cargo_status</option>";
                                            } else {
                                                echo "<option value=\"$cargo_status\">$cargo_status</option>";
                                            }
                                        }
                                    }
                                ?>
                              </select>
                            </div>
                        </div>
                        
                        <hr class="" />
                        
                        <div class="form-group">
                            <div class="col-sm-3" style="text-align: left;">
                                <a class="btn btn-success" href="index.php">ADD NEW SHIPMENT/CARGO</a>
                            </div>
                            <div class="col-sm-4" style="text-align: right;">
                              <button type="submit" id="submit" name="submit" value="UPDATE" class="btn btn-primary submit_btn">UPDATE</button>
                            </div>
                        </div>
                    </form>
                
                <?php } ?>
                    
                    
                    
            </div>
        </div>
    </div>

    <div id="footer">
        <?php require_once ('_footer.php'); ?>
    </div>



    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script type="text/javascript" src="js/jquery.js"></script>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script type="text/javascript" src="js/bootstrap.min.js"></script>  
    <script type="text/javascript" src="js/script.js"></script>  
  </body>
</html>