<?php
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require_once ('core/config.php');


if (!isset($_SESSION['logistics']['logged_in']) || !isset($_SESSION['logistics']['username']) || !isset($_SESSION['logistics']['password'])) {
    
    // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
    header("location: login.php");
    exit;
} else {    
    $user_data = $User->is_login_valid($_SESSION['logistics']['username'], $_SESSION['logistics']['password']);    
    if ($user_data === false) {
        // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
        header("location: login.php");
        exit;
    }
}
$user_id        = $user_data['user_id'];


// Check for Cargo record existence
if (isset($_GET['cid']) && $Transaction->get_cargo($_GET['cid']) !== false) {
    
    $cargo = $Transaction->get_cargo($_GET['cid']);
    $cargo_id = $cargo['cargo_id'];
	
	$username = (isset($_GET['user']))? trim($_GET['user']) : 'UNKNOWN';
    
} else {
    
    echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">';
    echo '<META HTTP-EQUIV=Refresh CONTENT="10; URL=index.php">';    
    echo exit ("Invalid shipment record");
}



// ADD
if (isset($_POST['submit']) && $_POST['submit'] == 'ADD' && $CSRF->check_valid('post')) {
    
    $remark         = trim($_POST['remark']);
    $location       = trim($_POST['location']);
    $date_time      = trim($_POST['datetime']);
    $status         = trim($_POST['status']);
           
    if (empty($remark) || empty($location) || empty($status) || empty($date_time)) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Something is missing! All form fields (*) is required.'); </script>";
        
    } else {
		
		if ($status == "Shipment Held")
		{
			$Transaction->update_cargo_field($cargo_id, 'expected_delivery_date', $exp_datetime);
		}
        
        //Add the cargo history record
        if ($Transaction->add_cargo_history($cargo_id, $remark, $location, $date_time) === true) {
            
            //update shipment status
            echo $Transaction->update_cargo_field($cargo_id, 'status', $status);
			
			if ($status == "Shipment Held")
			{
				if (!empty($cargo['expected_delivery_date'])) {
					$exp_dt_tm 	= strtotime($cargo['expected_delivery_date']);
					$nw 		= time();
					$nw_dt		= date('Y-m-d G:i:s', $nw);
					if ($exp_dt_tm > $nw) {
						
						$dt_diff = $exp_dt_tm - $nw;
						$day = floor($dt_diff / 86400);
						$hr  = floor(($dt_diff % 86400) / 3600);
						$min = floor(($dt_diff % 3600) / 60);
						$sec = ($dt_diff % 60);
						$exp_h_dt_text = "<span>$day</span><small class=\"text-muted\">days</small> ";
						$exp_h_dt_text .= "<span>$hr</span><small class=\"text-muted\">hrs</small> ";
						$exp_h_dt_text .= "<span>$min</span><small class=\"text-muted\">mins</small> ";
						$exp_h_dt_text .= "<span>$sec</span><small class=\"text-muted\">secs</small> ";
						$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date_text', $exp_h_dt_text);
						$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date', $nw_dt);
					}
				}
			} else {
				$nw	= time();
				$exp_dt_tm = strtotime($cargo['expected_delivery_date']);
				$exp_h_dt_tm = strtotime($cargo['expected_delivery_held_date']);
				if (!empty($cargo['expected_delivery_date']) && $exp_dt_tm > $exp_h_dt_tm) {
					$dt_diff 		= $exp_dt_tm - $exp_h_dt_tm;
					$new_exp_dt_tm 	= $nw + $dt_diff;
					$new_exp_dt		= date('Y-m-d G:i:s', $new_exp_dt_tm);			
					$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_date', $new_exp_dt);
				} else {
					$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_date', null);
				}
				
				$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date', null);
				$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date_text', null);
			}	
            
            $error = false;
			
			$alert_msg = "Shipment history added successfully.";
			$alert_msg = urlencode($alert_msg);
			header("location: cargo_history.php?trigger-alert-msg={$alert_msg}&user={$username}&cid={$cargo['cargo_id']}&".$CSRF->get_token_url_qstring());
			exit;
			
        } else {                
                
            $error = true;
            echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
        }   
    }      
}

// UPDATE CHECK and FORM DISPLAY
if (isset($_GET['upd']) && $Transaction->get_cargo_history($_GET['upd']) !== false && $CSRF->check_valid('get')) {
    
    $display_update_form = true;
    $update_history_data = $Transaction->get_cargo_history($_GET['upd']);
          
} else {
    $display_update_form = false;
}

// UPDATE
if (isset($_POST['submit']) && $_POST['submit'] == 'UPDATE' && $CSRF->check_valid('post')) {
    
    $history_id     = (int) trim($_POST['history_id']);
    $remark         = trim($_POST['remark']);
    $location       = trim($_POST['location']);
    $date_time      = trim($_POST['datetime']);
    $status         = trim($_POST['status']);
           
    if (empty($history_id) || empty($remark) || empty($location) || empty($status) || empty($date_time)) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Something is missing! All form fields (*) is required.'); </script>";
        
    } else {
        
        if ($Transaction->get_cargo_history($history_id) !== false) {
            
            //Update cargo records
            $Transaction->update_cargo_history_field($history_id, 'remark', $remark);
            $Transaction->update_cargo_history_field($history_id, 'location', $location);
            $Transaction->update_cargo_history_field($history_id, 'date_added', $date_time);
            //update shipment status
            $Transaction->update_cargo_field($cargo_id, 'status', $status);
			
			if ($status == "Shipment Held")
			{
				if (!empty($cargo['expected_delivery_date'])) {
					$exp_dt_tm 	= strtotime($cargo['expected_delivery_date']);
					$nw 		= time();
					$nw_dt		= date('Y-m-d G:i:s', $nw);
					if ($exp_dt_tm > $nw) {
						
						$dt_diff = $exp_dt_tm - $nw;
						$day = floor($dt_diff / 86400);
						$hr  = floor(($dt_diff % 86400) / 3600);
						$min = floor(($dt_diff % 3600) / 60);
						$sec = ($dt_diff % 60);
						$exp_h_dt_text = "<span>$day</span><small class=\"text-muted\">days</small> ";
						$exp_h_dt_text .= "<span>$hr</span><small class=\"text-muted\">hrs</small> ";
						$exp_h_dt_text .= "<span>$min</span><small class=\"text-muted\">mins</small> ";
						$exp_h_dt_text .= "<span>$sec</span><small class=\"text-muted\">secs</small> ";
						$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date_text', $exp_h_dt_text);
						$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date', $nw_dt);
					}
				}
			} else {
				$nw	= time();
				$exp_dt_tm = strtotime($cargo['expected_delivery_date']);
				$exp_h_dt_tm = strtotime($cargo['expected_delivery_held_date']);
				if (!empty($cargo['expected_delivery_date']) && $exp_dt_tm > $exp_h_dt_tm) {
					$dt_diff 		= $exp_dt_tm - $exp_h_dt_tm;
					$new_exp_dt_tm 	= $nw + $dt_diff;
					$new_exp_dt		= date('Y-m-d G:i:s', $new_exp_dt_tm);			
					$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_date', $new_exp_dt);
				} else {
					$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_date', null);
				}
				
				$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date', null);
				$Transaction->update_cargo_field($cargo['cargo_id'], 'expected_delivery_held_date_text', null);
			}			
            
            //reload form values with updated records
            $update_cargo_data = $Transaction->get_cargo($cargo_id);
            
            $error = false;
			
			$alert_msg = "Shipment history updated successfully.";
			$alert_msg = urlencode($alert_msg);
			header("location: cargo_history.php?trigger-alert-msg={$alert_msg}&user={$username}&cid={$cargo['cargo_id']}&".$CSRF->get_token_url_qstring());
			exit;
           
                
        } else {                
                
            $error = true;
            echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
        }              
    }      
}


// DELETE
if (isset($_GET['del']) && $Transaction->get_cargo_history($_GET['del']) !== false && $CSRF->check_valid('get')) {   
    
    if ($Transaction->delete_cargo_history($_GET['del']) === true) {    
        echo "<script type='text/javascript'> alert('Shipment history deleted successfully.'); </script>";  
    } else {                
            
        echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
    }    
}



// Send SMS
if (isset($_POST['submit']) && $_POST['submit'] == 'SEND_SMS' && $CSRF->check_valid('post')) {
    
    $sms_to         = trim($_POST['sms_phone_no']);
    $sms_message    = trim($_POST['sms_message']);
    
    if (empty($sms_to) || empty($sms_message)) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Something is missing! All form fields (*) is required.'); </script>";
        
    } else {
            
		if ($config['sms_api'] == 'nimbow') {
		  $SMS_Client = new SMS_Lib($config['sms_api_key'], $config['sms_submit_method']);  
		} else {
		  $SMS_Client = new SMS_Lib($config['sms_api_key'], $config['sms_api_secret'], $config['sms_submit_method']);  
		} 
		
		$to_no_plus = preg_replace("/\+/", '', $sms_to); //remove any + symbol before the phone number as required by  API
		$from_no_plus = preg_replace("/\+/", '', $config['sms_from']); //remove any + symbol before the phone number as required by API
		
		//call API to send sms                                
		$api_response = $SMS_Client->send_message($from_no_plus, $to_no_plus, $sms_message);
			if ($api_response['status'] == 'OK') {
			echo "<script type='text/javascript'> alert('SMS sent.'); </script>";
		} else {
			echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
		}		
    }
}




// Send Shipment Confirmation Notification
if (isset($_GET['notify']) && $_GET['notify'] == 'shipment-confirmation' && $CSRF->check_valid('get')) {   
    
    $notify_successful =  false;
    
    // SEND EMAIL NOTIFICATION
    if (!empty($cargo['receiver_email'])) {
        $mailer             = new PHPMailer;
        $mailer->Host       = $config['smtp_host']; 
        $mailer->Username   = $config['smtp_username'];
        $mailer->Password   = $config['smtp_password'];
        $mailer->Port       = $config['smtp_port'];
        $mailer->SMTPAuth   = $config['smtp_auth'];
        $mailer->SMTPSecure = $config['smtp_secure'];
        $mailer->SMTPDebug  = false;
        $mailer->IsSMTP();                // set mailer to use SMTP     // turn on SMTP authentication      
        $mailer->From       = $config['smtp_from'];
        $mailer->FromName   = $config['smtp_from_name'];            
        $mailer->AddAddress($cargo['receiver_email'], "{$cargo['receiver']}");
        $mailer->addReplyTo($config['app_customer_care_email']);
        $mailer->Subject = "{$config['app_name']} Shipment Confirmation: " . $cargo['tracking_code'];
        $body = "<img width=\"200\" src=\"https://" . $config['app_domain'] . "/images/logo.png\" alt=\"{$config['app_name']}\"> \r\n\r\n";
        $body .= "This shipment has been created with " . strtoupper($config['app_name']) . ".<hr> \r\n";
        $body .= "Tracking Number: <b>{$cargo['tracking_code']}</b>.\r\n\r\n";
		$body .= "Pickup Date: <b>" . strtoupper($cargo['date_added']) . "</b>.\r\n"; 
		if (!empty($cargo['expected_delivery_date'])) {
			$body .= "Estimated Delivery Date: <b>" . strtoupper($cargo['expected_delivery_date']) . "</b>.\r\n"; 
		}
        $body .= "<hr>";
        $body .= "Shipment To: \r\n <b>";
        $body .= strtoupper($cargo['receiver']) . ".\r\n";
        $body .= strtoupper($cargo['destination']) . ". </b> \r\n\r\n";
		$body .= "Shipment From: \r\n <b>";
        $body .= strtoupper($cargo['sender']) . ".\r\n";
        $body .= strtoupper($cargo['origin']) . ". </b> \r\n\r\n";
		$body .= "Shipment Contents/Description: \r\n <b>";
        $body .= strtoupper($cargo['description']) . "</b> <hr> \r\n"; 		
        $body .= "If you wish to track this shipment, please visit the {$config['app_name']} Website at \r\n";
        $body .= "https://" . $config['app_domain'] . " \r\n\r\n";
        $body .= "If you have a Web-enabled mail reader or browser, click the link below to view shipment tracking details: \r\n\r\n";
		$body .= "https://" . $config['app_domain'] . "/tracking-result.php?tcode=" . $cargo['tracking_code'] . " \r\n\r\n";
        $body .= "Thank you for requesting {$config['app_name']} for your delivery needs.";
        $mailer->Body = nl2br($body);
        $mailer->AltBody = strip_tags($body);
        
        // Send email using smtp
        if($mailer->Send()) {  
            $notify_successful = true;
        } else {
            //
        }
    }    
    
    // SEND SMS NOTIFICATION
	if ($config['sms_enabled'] == true) {
		if (!empty($cargo['receiver_phone'])){
		
			if ($config['sms_api'] == 'nimbow') {
				$SMS_Client = new SMS_Lib($config['sms_api_key'], $config['sms_submit_method']);  
			} else {
				$SMS_Client = new SMS_Lib($config['sms_api_key'], $config['sms_api_secret'], $config['sms_submit_method']);  
			} 
			
			$sms_message = "A shipment has been created with " . strtoupper($config['app_name_short']) . " ";
			$sms_message .= "with Tracking No: {$cargo['tracking_code']}. Track details at " . "https://" . $config['app_domain'];
			
			$to_no_plus = preg_replace("/\+/", '', $cargo['receiver_phone']); //remove any + symbol before the phone number as required by NEXMO API
			$from_no_plus = preg_replace("/\+/", '', $config['sms_from']); //remove any + symbol before the phone number as required by NEXMO API
			
			//call API to send sms                                
			$api_response = $SMS_Client->send_message($from_no_plus, $to_no_plus, $sms_message);
			if ($api_response['status'] == 'OK') {
				$notify_successful = true;
			}
		}
	}
    
    if ($notify_successful === true) {    
         $alert_msg = "Notification sent.";
    } else {               
         $alert_msg = "Unable to perform request at the moment. Please try again or contact webmaster.";
    }    
    $alert_msg = urlencode($alert_msg);
    header("location: cargo_history.php?trigger-alert-msg={$alert_msg}&user={$username}&cid={$cargo['cargo_id']}&".$CSRF->get_token_url_qstring());
    exit;
}


// Send Shipment Status Notification
if (isset($_GET['notify']) && $_GET['notify'] == 'shipment-status' && $CSRF->check_valid('get')) {   
    
    $notify_successful =  false;
	
	$last_cargo_history = $Transaction->get_last_cargo_history($cargo_id);	
	if ($last_cargo_history != false && is_array($last_cargo_history)) {
		
		// SEND EMAIL NOTIFICATION
		if (!empty($cargo['receiver_email'])) {
			$mailer             = new PHPMailer;
			$mailer->Host       = $config['smtp_host']; 
			$mailer->Username   = $config['smtp_username'];
			$mailer->Password   = $config['smtp_password'];
			$mailer->Port       = $config['smtp_port'];
			$mailer->SMTPAuth   = $config['smtp_auth'];
			$mailer->SMTPSecure = $config['smtp_secure'];
			$mailer->SMTPDebug  = false;
			$mailer->IsSMTP();                // set mailer to use SMTP     // turn on SMTP authentication      
			$mailer->From       = $config['smtp_from'];
			$mailer->FromName   = $config['smtp_from_name'];            
			$mailer->AddAddress($cargo['receiver_email'], "{$cargo['receiver']}");
			$mailer->addReplyTo($config['app_customer_care_email']);
			$mailer->Subject = "{$config['app_name']} Shipment Notification: " . $cargo['tracking_code'];
			$body = "<img width=\"200\" src=\"https://" . $config['app_domain'] . "/images/logo.png\" alt=\"{$config['app_name']}\"> \r\n\r\n";
			$body .= "Notification for shipment event status <b>\"{$cargo['status']}\"</b>.<hr> \r\n";
			$body .= "Tracking Number: <b>{$cargo['tracking_code']}</b>.\r\n\r\n";
			$body .= "Pickup Date: <b>" . strtoupper($cargo['date_added']) . "</b>.\r\n"; 
			if (!empty($cargo['expected_delivery_date'])) {
				$body .= "Estimated Delivery Date: <b>" . strtoupper($cargo['expected_delivery_date']) . ".</b><hr> \r\n"; 
			}
			$body .= "Status Event: \r\n";
			$body .= "<b>{$last_cargo_history['date_added']} - {$last_cargo_history['remark']} - " . strtoupper($last_cargo_history['location']) . "</b> <hr>\r\n"; 
			$body .= "Shipment To: \r\n <b>";
			$body .= strtoupper($cargo['receiver']) . ".\r\n";
			$body .= strtoupper($cargo['destination']) . ". </b> \r\n\r\n";
			$body .= "Shipment From: \r\n <b>";
			$body .= strtoupper($cargo['sender']) . ".\r\n";
			$body .= strtoupper($cargo['origin']) . ". </b> \r\n\r\n";
			$body .= "Shipment Contents/Description: \r\n <b>";
			$body .= strtoupper($cargo['description']) . "</b> <hr> \r\n"; 		
			$body .= "If you wish to track this shipment, please visit the {$config['app_name']} Website at \r\n";
			$body .= "https://" . $config['app_domain'] . " \r\n\r\n";
			$body .= "If you have a Web-enabled mail reader or browser, click the link below to view shipment tracking details: \r\n\r\n";
			$body .= "https://" . $config['app_domain'] . "/tracking-result.php?tcode=" . $cargo['tracking_code'] . "&h={$last_cargo_history['history_id']} \r\n\r\n";
			$body .= "Thank you! \r\n{$config['app_name']}";
			$mailer->Body = nl2br($body);
			$mailer->AltBody = strip_tags($body);
			
			// Send email using smtp
			if($mailer->Send()) {  
				$notify_successful = true;
			} else {
				//
			}
		}    
		
		// SEND SMS NOTIFICATION
		if ($config['sms_enabled'] == true) {
			if (!empty($cargo['receiver_phone'])){
			
				if ($config['sms_api'] == 'nimbow') {
					$SMS_Client = new SMS_Lib($config['sms_api_key'], $config['sms_submit_method']);  
				} else {
					$SMS_Client = new SMS_Lib($config['sms_api_key'], $config['sms_api_secret'], $config['sms_submit_method']);  
				} 
				
				$sms_message = "The status of shipment with Tracking No: {$cargo['tracking_code']} has been updated. ";
				$sms_message .= "Track details at " . "https://" . $config['app_domain'];
				
				$to_no_plus = preg_replace("/\+/", '', $cargo['receiver_phone']); //remove any + symbol before the phone number as required by NEXMO API
				$from_no_plus = preg_replace("/\+/", '', $config['sms_from']); //remove any + symbol before the phone number as required by NEXMO API
				
				// call API to send sms                    
				/* * /
				$api_response = $SMS_Client->send_message($from_no_plus, $to_no_plus, $sms_message);
				if ($api_response['status'] == 'OK') {
					$notify_successful = true;
				}
				/* */
			}
		}
	}
    
    if ($notify_successful === true) {    
         $alert_msg = "Notification sent.";
    } else {               
         $alert_msg = "Unable to perform request at the moment or ensure there is at least one(1) shipment history. Please Try again or contact webmaster.";
    }    
    $alert_msg = urlencode($alert_msg);
    header("location: cargo_history.php?trigger-alert-msg={$alert_msg}&user={$username}&cid={$cargo['cargo_id']}&".$CSRF->get_token_url_qstring());
    exit;
}





// ERROR / SUCCESS ALERT MESSAGE TRIGGER to avoid double submission
if (isset($_GET['trigger-alert-msg']) && $_GET['trigger-alert-msg'] != '' && $CSRF->check_valid('get')) {   
    
    $alert_msg = urldecode($_GET['trigger-alert-msg']);
    echo "<script type='text/javascript'> alert('$alert_msg'); </script>";      
}




//Reload cargo records with updated values
$cargo = $Transaction->get_cargo($_GET['cid']);
$cargo_id = $cargo['cargo_id'];

// Get all histories for the selected cargo record
$cargo_histories = $Transaction->get_cargo_histories($cargo_id);



?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <meta name="robots" content="index" />
    <meta name="googlebot" content="index" />
    <meta name="robots" content="follow" />
    <meta name="robots" content="nocache" /> 
    <meta http-equiv="cache-control" content="no-cache" />                       
	<meta http-equiv="expires" content="-1" />
    
    <base href="" />
    
    <title><?php echo $cargo['tracking_code']?> Shipment History | <?php echo $config['app_name'];?></title>


    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet" />

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>
  <body>
  
    <div id="header">
        <?php require_once ('_header.php'); ?>  
    </div>
    
    <div id="content" class="container">
        
        <div class="row">
            <?php require_once ('_main_top.php'); ?>          
        </div>
        
        <div class="row">
            <div class="col-md-2" id="sidebar">
                <?php require_once ('_sidebar.php'); ?>
            </div>
            
            
            <div class="col-md-10">
                
                <br />
                <table class="table table-responsive  table-bordered">
                     
                        <tr>                                                               
                            <th>Tracking Number</th>                              
                            <td><?php echo $cargo['tracking_code']?></td>
                            <th>Sender</th>
                            <td><?php echo $cargo['sender']?></td>
                            <th>Origin</th>
                            <td><?php echo $cargo['origin']?></td>
                        </tr>
                        <tr>                                                               
                            <th>Description</th>
                            <td><?php echo $cargo['description']?></td>
                            <th>Receiver</th>
                            <td>
								<?php echo $cargo['receiver']?><br>
								<?php echo $cargo['receiver_phone'];?><br>
								<?php echo $cargo['receiver_email'];?>
							</td>
                            <th>Destination</th>
                            <td><?php echo $cargo['destination']?></td>
                        </tr>
                        <tr>                                                               
                            <th>Status</th>
                            <td colspan="3">
								<?php 
									if ($cargo['status'] == "Shipment Held") {
										echo "<span style=\"color: red;\">" . $cargo['status'] . "</span>";
									} else {
										echo $cargo['status'];
									}												
								?>
							</td>
                            <th>Date</th>
                            <td><?php echo $cargo['date_added']?></td>
                        </tr>
                </table>
				
				<hr class="hr_style" />
					
				<fieldset>
					<legend>Send Notification to the receiver</legend>
					<ol>
						<li>
							<b><a href="cargo_history.php?notify=shipment-confirmation&user=<?php echo $username.'&cid='.$cargo['cargo_id']."&".$CSRF->get_token_url_qstring();?>" onclick="return confirm('CONFIRMATION: \n\n Are you sure you want to Send Shipment Confirmation Notification?');">Send Shipment Confirmation/Creation Notification</a></b> 
							<br> <i><small>(Please <b>Send Once</b> to the receiver/client, just after creating the shipment record)</small></i>
						</li>
						<br>
						<li>
							<b><a href="cargo_history.php?notify=shipment-status&user=<?php echo $username.'&cid='.$cargo['cargo_id']."&".$CSRF->get_token_url_qstring();?>" onclick="return confirm('CONFIRMATION: \n\n Are you sure you want to Send Current Shipment Status and Location Notification?');">Send Current Shipment Status and Location Notification</a> </b>
							<br> <i><small>(Send after adding each shipment history to notify receiver/client of the current status and location)</small></i>
						</i>
						
					</ol>
				</fieldset>
                
                <hr class="hr_style" />
                
                <div class="row">
                
                    <div class="col-sm-7">
					
						<?php if ($display_update_form === false) {?>
						
							<h3 class="page_label">Add Shipment History</h3>
							<hr />          
							
							<form class="form-horizontal" method="post" action="" onsubmit="return confirm('CONFIRMATION: \n\n Are you sure the information you entered is correct?');">
								<?php $CSRF->echo_token_input_field(); ?>        
								<div class="form-group">
									<label for="remark" class="col-sm-5 control-label">Shipment Remark/Comment: *</label>
									<div class="col-sm-7">
									  <textarea class="form-control" id="remark" name="remark" placeholder="Shipment Remark/Comment" maxlength="250" required><?php if ($error === true && isset($_POST['remark'])) { echo trim($_POST['remark']);}?></textarea>
									</div>
								</div>
								<div class="form-group">
									<label for="location" class="col-sm-5 control-label">Event Location: *</label>
									<div class="col-sm-7">
									  <input type="text" class="form-control" id="location" name="location" placeholder="Event Location" value="<?php if ($error === true && isset($_POST['location'])) { echo trim($_POST['location']);} ?>" maxlength="50" required>
									</div>
								</div>
								<div class="form-group">
									<label for="datetime" class="col-sm-5 control-label">Date/Time: *</label>
									<div class="col-sm-7">
									  <input type="text" class="form-control" id="datetime" name="datetime" placeholder="YYYY-MM-DD HH:MM:SS" value="<?php if ($error === true && isset($_POST['datetime'])) { echo trim($_POST['datetime']);} else { echo date('Y-m-d G:i:s'); } ?>" required>
									</div>
								</div>
								<div class="form-group">
									<label for="status" class="col-sm-5 control-label">Change Shipment Status to: *</label>
									<div class="col-sm-7">
									  <select class="form-control" id="status" name="status" placeholder="Shipment Status" required>
										<?php
											if (isset($config['app_cargo_status']) && is_array($config['app_cargo_status'])) {
												foreach ($config['app_cargo_status'] as $cargo_status) {
													
													$selected_status = ($error === true && isset($_POST['status'])) ? trim($_POST['status']) : $cargo['status'];
													
													if ($selected_status == $cargo_status) {
														echo "<option value=\"$cargo_status\" selected=\"selected\">$cargo_status</option>";
													} else {
														echo "<option value=\"$cargo_status\">$cargo_status</option>";
													}
												}
											}
										?>
									  </select>
									</div>
								</div>
								
								<hr class="" />
								
								<div class="form-group">
									<div class="col-sm-7" style="text-align: right;">
									  <button type="reset" id="submit" name="submit" class="btn" >RESET</button>
									  <button type="submit" id="submit" name="submit" value="ADD" class="btn btn-primary submit_btn">ADD SHIPMENT HISTORY</button>
									</div>
								</div>                        
							</form>
							
						<?php } else { ?>
						
							<h3 class="page_label">Update Shipment History</strong></h3>
							<hr />          
							
							<form class="form-horizontal" method="post" action="" onsubmit="return confirm('CONFIRMATION: \n\n Are you sure the information you entered is correct?');">
								<?php $CSRF->echo_token_input_field(); ?>
								<input type="hidden" name="history_id" value="<?php echo $update_history_data['history_id'];?>" />
													 
								<div class="form-group">
									<label for="remark" class="col-sm-5 control-label">Shipment Remark/Comment: *</label>
									<div class="col-sm-7">
									  <textarea class="form-control" id="remark" name="remark" placeholder="Shipment Remark/Comment" maxlength="250" required><?php echo ($error === true && isset($_POST['remark'])) ? trim($_POST['remark']) : $update_history_data['remark'];?></textarea>
									</div>
								</div>
								<div class="form-group">
									<label for="location" class="col-sm-5 control-label">Event Location: *</label>
									<div class="col-sm-7">
									  <input type="text" class="form-control" id="location" name="location" placeholder="Event Location" value="<?php echo ($error === true && isset($_POST['location'])) ? trim($_POST['location']) : $update_history_data['location'];?>" maxlength="50" required>
									</div>
								</div>     
								<div class="form-group">
									<label for="datetime" class="col-sm-5 control-label">Date/Time: *</label>
									<div class="col-sm-7">
									  <input type="text" class="form-control" id="datetime" name="datetime" placeholder="YYYY-MM-DD HH:MM:SS" value="<?php echo ($error === true && isset($_POST['datetime'])) ? trim($_POST['datetime']) : $update_history_data['date_added'];?>" maxlength="50" required>
									</div>
								</div>                            
								<div class="form-group">
									<label for="status" class="col-sm-5 control-label">Change Shipment Status to: *</label>
									<div class="col-sm-7">
									  <select class="form-control" id="status" name="status" placeholder="Shipment Status" required>
										<?php
											if (isset($config['app_cargo_status']) && is_array($config['app_cargo_status'])) {
												foreach ($config['app_cargo_status'] as $cargo_status) {
													
													$selected_status = ($error === true && isset($_POST['status'])) ? trim($_POST['status']) : $cargo['status'];
													
													if ($selected_status == $cargo_status) {
														echo "<option value=\"$cargo_status\" selected=\"selected\">$cargo_status</option>";
													} else {
														echo "<option value=\"$cargo_status\">$cargo_status</option>";
													}
												}
											}
										?>
									  </select>
									</div>
								</div>
								
								<hr class="" />
								
								<div class="form-group">
									<div class="col-sm-3" style="text-align: left;">
										<a class="btn btn-success" href="cargo_history.php?cid=<?php echo $cargo_id."&".$CSRF->get_token_url_qstring();?>">ADD NEW HISTORY</a>
									</div>
									<div class="col-sm-4" style="text-align: right;">
									  <button type="submit" id="submit" name="submit" value="UPDATE" class="btn btn-primary submit_btn">UPDATE HISTORY</button>
									</div>
								</div>
							</form>
						
						<?php } ?>
					
					</div>
					
					<?php if (1 == 2) { ?>
					<div class="col-sm-5" style="background: #ccc;">
						<h3 class="page_label">Send SMS</h3>
							<hr />          
							
							<form class="form-horizontal" method="post" action="" onsubmit="return confirm('CONFIRMATION: \n\n Are you sure you want to Send SMS to the specified phone number?');">
								<?php $CSRF->echo_token_input_field(); ?> 
								<div class="form-group">
									<label for="sms_sender" class="col-sm-5 control-label">Sender: *</label>
									<div class="col-sm-7">
									  <?php if (isset($config['sms_from'])) { echo $config['sms_from'];} ?>
									</div>
								</div>   
								<div class="form-group">
									<label for="phone_label" class="col-sm-5 control-label">Phone Number: *</label>
									<div class="col-sm-7">
										<input type="hidden" name="sms_phone_no" value="<?php echo $cargo['receiver_phone'];?>" />
										<input type="text" class="form-control" id="phone_label" value="<?php echo $cargo['receiver_phone'];?>" maxlength="20" disabled>
										<!--<span class="help-block">Internation format with leading plus (+) e.g +447106534443.</span>-->
									</div>
								</div>     
								<div class="form-group">
									<label for="sms_message" class="col-sm-5 control-label">Message: *</label>
									<div class="col-sm-7">
									  <textarea class="form-control" id="sms_message" name="sms_message" placeholder="Message" maxlength="160" rows="5" required><?php if ($error === true && isset($_POST['sms_message'])) { echo trim($_POST['sms_message']);}?></textarea>
									  <span>160 characters maximum.</span>
									</div>
								</div>
								
								<hr class="" />
								
								<div class="form-group">
									<div class="col-sm-12" style="text-align: right;">
									  <button type="submit" name="submit" value="SEND_SMS" class="btn btn-primary submit_btn">SEND SMS</button>
									</div>
								</div>                        
							</form>
                     </div>
					 <?php } ?>
					 
                </div>
                    
					
					
					
                    <hr class="hr_style" />
                    
                    <table class="table table-responsive table-striped table-bordered">
                        <thead>
                            <tr>                                                             
                                <th>Remark</th>
                                <th>Event Location</th> 
                                <th>Date</th>
                                <th>[...]</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php 
                                if ($cargo_histories === false) {
                                    echo '<tr><td colspan="3">No shipment history recorded<td></tr>';
                                } else { 
                                    foreach ($cargo_histories as $cargo_history)
                                    {
                            ?>                                                                        
                                        <tr>                                 
                                            <td><?php echo $cargo_history['remark']?></td>
                                            <td><?php echo $cargo_history['location']?></td>
                                            <td><?php echo $cargo_history['date_added'];?></td>
                                            <td>
                                                <a href="cargo_history.php?cid=<?php echo $cargo_id.'&upd='.$cargo_history['history_id']."&".$CSRF->get_token_url_qstring();?>">Update</a> |
                                                <a href="cargo_history.php?cid=<?php echo $cargo_id.'&del='.$cargo_history['history_id']."&".$CSRF->get_token_url_qstring();?>" onclick="return confirm('CONFIRMATION: \n\n Are you sure you want to DELETE shipment history at event location: <?php echo $cargo_history['location']?>?');">Delete</a>
                                            </td>
                                        </tr>
                            <?php 
                                    }
                                }
                            ?>
                        </tbody>
                    </table> 
                    
            </div>
        </div>
    </div>

    <div id="footer">
        <?php require_once ('_footer.php'); ?>
    </div>



    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script type="text/javascript" src="js/jquery.js"></script>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script type="text/javascript" src="js/bootstrap.min.js"></script>  
    <script type="text/javascript" src="js/script.js"></script>  
  </body>
</html>