<?php
require_once ('core/config.php');


if (!isset($_SESSION['logistics']['logged_in']) || !isset($_SESSION['logistics']['username']) || !isset($_SESSION['logistics']['password'])) {
    
    // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
    header("location: login.php");
    exit;
} else {    
    $user_data = $User->is_login_valid($_SESSION['logistics']['username'], $_SESSION['logistics']['password']);    
    if ($user_data === false) {
        // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
        header("location: login.php");
        exit;
    }
}

$user_id        = $user_data['user_id'];


if (isset($_POST['submit']) && $_POST['submit'] == 'CHANGE' && $CSRF->check_valid('post')) {
    
    $password           = trim($_POST['password']);
    $new_password       = trim($_POST['new_password']);
    $new_password_re    = trim($_POST['new_password_re']);
        
    if (empty($password) || empty($new_password) || empty($new_password_re)) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Something is missing! All form fields is required.'); </script>";
        
    } elseif (strlen($new_password) < 6) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Your New Password must be 6 characters.'); </script>";
        
    } elseif ($new_password != $new_password_re) { 
        $error = true;
        echo "<script type='text/javascript'> alert('New Password did not match with confirmation.'); </script>";
        
    } elseif (sha1($password) != $user_data['password']) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Invalid Current Password.'); </script>";
        
    } elseif ($password == $new_password) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Your New Password cannot be the same as your current Password.'); </script>";
        
    } else {
    
            //update password
            if ($User->update_field($user_data['user_id'], 'password', sha1($new_password))) {
                
                echo "<script type='text/javascript'> alert('Password change successfully. You will be redirected to login again with your new password.'); </script>";
                
                echo '<META HTTP-EQUIV=Refresh CONTENT="0; URL=">'; 
                 
            } else {
                
                echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact our customer service centre.'); </script>";
            }   
    }      
}


?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <meta name="robots" content="index" />
    <meta name="googlebot" content="index" />
    <meta name="robots" content="follow" />
    <meta name="robots" content="nocache" /> 
    <meta http-equiv="cache-control" content="no-cache" />                       
	<meta http-equiv="expires" content="-1" />
    
    <base href="" />
    
    <title>Change Password | <?php echo $config['app_name'];?> Online Banking</title>


    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet" />

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>
  <body>
  
    <div id="header">
        <?php require_once ('_header.php'); ?>  
    </div>
    
    <div id="content" class="container">
        
        <div class="row">
            <?php require_once ('_main_top.php'); ?>          
        </div>
        
        <div class="row">
            <div class="col-md-2" id="sidebar">
                <?php require_once ('_sidebar.php'); ?>
            </div>
            
            
            <div class="col-md-10">
                    <h3 class="page_label">Change Password</h3>
                    <hr />          
                    
                    <form class="form-horizontal" method="post" action="">
                        <?php $CSRF->echo_token_input_field(); ?>
                    
                        <div class="form-group">
                            <label for="password" class="col-sm-3 control-label">Current Password:</label>
                            <div class="col-sm-4">
                              <input type="password" class="form-control" id="password" name="password" placeholder="Current Password" value="" maxlength="50" required>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="m_name" class="col-sm-3 control-label">New Password:</label>
                            <div class="col-sm-4">
                              <input type="password" class="form-control" id="new_password" name="new_password" placeholder="New Password" value="" maxlength="50" required>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="new_password_re" class="col-sm-3 control-label">Re-enter New Password:</label>
                            <div class="col-sm-4">
                              <input type="password" class="form-control" id="new_password_re" name="new_password_re" placeholder="Re-enter New Password" value="" maxlength="50" required>
                            </div>
                        </div>
                        
                        <hr class="" />
                        
                        <div class="form-group">
                            <div class="col-sm-7" style="text-align: right;">
                              <button type="reset" id="submit" name="submit" class="btn" >RESET</button>
                              <button type="submit" id="submit" name="submit" value="CHANGE" class="btn btn-primary submit_btn">CHANGE PASSCODE</button>
                            </div>
                        </div>  
                        
                        <hr class="hr_style" />
                    </form>

            </div>
        </div>
    </div>

    <div id="footer">
        <?php require_once ('_footer.php'); ?>
    </div>



    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script type="text/javascript" src="js/jquery.js"></script>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script type="text/javascript" src="js/bootstrap.min.js"></script>  
    <script type="text/javascript" src="js/script.js"></script>  
  </body>
</html>