

;(function($) {
	"use strict";
	$.HandleElement = $.HandleElement || {};

	var defaults = {
		replaces : '',
		min_column_span : 2,
		layout_span : 12,
		new_sub_element : false,
		add_item : 0,
		curr_iframe_ : null,
		clicked_column : null,
		if_childmodal : 0,
		effect: 'easeOutCubic'
	};

	var clk_title_el, 
			append_title_el,
			el_type,
			input_enter,
			btn_delete_clicked,
			active_column = 0,
			active_element = 0,
			MM_ID = 'media-manager';
	
	/***************************************************************************
	 * 1. Common
	 **************************************************************************/

	// alias for jQuery
	$.HandleElement.selector = function (curr_iframe, element) {
		var $selector = (curr_iframe != null && curr_iframe.contents() != null) ? curr_iframe.contents().find(element) : window.parent.jQuery.noConflict()(element);
		return $selector;
	};

	// Capitalize first character of whole string
	$.HandleElement.capitalize = function (text) {
		return text.charAt(0).toUpperCase()
		+ text.slice(1).toLowerCase();
	};

	// Capitalize first character of each word
	$.HandleElement.ucwords = function (text) {
		return (text + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) {
			return $1.toUpperCase();
		});
	};

	// Remove underscore character from string
	$.HandleElement.remove_underscore_ucwords = function (text) {
		var arr = text.split('_');
		return $.HandleElement.ucwords( arr.join(' ') ).replace(/^(Wp)\s+/g, '');
	};

	// Strip HTML tag from string
	$.HandleElement.strip_tags = function (input, allowed) {
		// Make sure the allowed argument is a string containing only tags in lowercase (<a><b><c>)
		allowed = (((allowed || '') + '').toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join('');

		var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi, commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;

		return input.replace(commentsAndPhpTags, '').replace(tags, function($0, $1) {
			return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
		});
	};

	// Get n first words of string
	$.HandleElement.sliceContent = function (text, limit) {
		text = unescape(text);
		text = text.replace(/\+/g, ' ');
		text = $.HandleElement.strip_tags(text);

		var arr = text.split(' ');
			arr = arr.slice(0, limit ? limit : 10);
		return arr.join(' ');
	};

	// Get cookie value by key
	$.HandleElement.getCookie = function (c_name) {
		if ( ! c_name )
			return null;
		c_name = c_name + "=";
		var ca = document.cookie.split(';');
		for(var i=0;i < ca.length;i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1,c.length);
			if (c.indexOf(c_name) == 0) return c.substring(c_name.length,c.length);
		}
		return null;
	};

	// Store cookie data
	$.HandleElement.setCookie = function (c_name, c_value) {
		c_value = c_value + ";max-age=" + 60 * 3 + ";path=/";
		document.cookie	= c_name + "=" + c_value;
	};

	// Remove cookie
	$.HandleElement.removeCookie = function (c_name) {
		if (!c_name)
			return null;
		document.cookie = c_name + "=;max-age=0;path=/";
	};
	
  $.HandleElement.createElement = function(string) {
    var div;
    div = document.createElement("div");
    div.innerHTML = string;
    return div.childNodes[0];
  };

	/*******************************************************************
	 * 3. PageSB
	 ******************************************************************/

	$.HandleElement.addElement = function() {
		var SB = {};
		var MM = $('#'+MM_ID), selectedImage, curImageDiv;
		SB.sid = WF.site;
		SB.lid = WF.lid;
		SB.layout = WF.layout;
		
		$("body").delegate(".publish-layout","click",function(e) {
			_publish(e, this);
			return false;
		});
		
		$("body").delegate(".unpublish-layout","click",function(e) {
			_unpublish(e, this);
			return false;
		});
				
		$("body").delegate(".wf-add-row","click",function(e) {
			_add_row(e, this);
			return false;
		});
		
		$("body").delegate(".wf-delete-row","click",function(e) {
			_delete_row(e, this);
			return false;
		});
		
		$("body").delegate(".wf-delete-col","click",function(e) {
			_delete_col(e, this);
			return false;
		});
		//
		$("body").delegate(".wf-add-element","click",function(e) {
			_add(e, this);
			return false;
		});
		
		$("body").delegate(".wf-style-column","click",function(e) {
			_style_column(e, this);
			return false;
		});
		
		$( ".pane-content" )
			.mouseenter(function() {
					$(this).children('.pane-content-control').show();
			})
			.mouseleave(function() {
					$(this).children('.pane-content-control').hide();
			});
		$("body").delegate(".pane-content-edit","click",function(e) {
			_edit(e, this);
		});
		
		$("body").delegate(".pane-content-move","mousedown",function(e) {
			_move(e, this);
			return false;
		});
		
		$("body").delegate(".pane-content-delete","click",function(e) {
			_delete(e, this);
			return false;
		});
		
		function _publish(e, this_) {
			$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'publish_layout',sid:SB.sid, lid:SB.lid}, function(response){
				if (response.code == 1) {
					alert("Published!");
				}
			});
		}
		
		function _unpublish(e, this_) {
			if (confirm("Are you sure you want to unpublish?")) {
				$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'unpublish_layout',sid:SB.sid, lid:SB.lid}, function(response){
					if (response.code == 1) {
						alert("Unpublished!");
					}
				});
			}
			return false;
		}
		
		function _edit(e, this_) {
			e.preventDefault();
			var obj = $(this_).parents('.pane-content');
			SB.colid = obj.attr('data-colid');
			SB.paneid = obj.attr('id');
			_Select(e, obj, SB.paneid);
		}
		
		function _move(e, this_) {
			e.preventDefault();
			var obj = $(this_).parents('.pane-content'), target, origin;
			
			SB.colid = obj.attr('data-colid');
			SB.paneid = obj.attr('id');
			
			origin = $( this ).parents(".col");
			$('#pane-moving').remove();
			var posY = $(window).scrollTop()+e.clientY-20;
			var posX = e.clientX-20;
			$('<div id="pane-moving" class="round25"><i class="fa fa-arrows fa-2x"></i></div>').css({'top':posY, 'left':posX}).appendTo("body").draggable({
				revert: "invalid", // when not dropped, the item will revert back to its initial position
				containment: "#main-content",
				activeClass: "ui-state-hover",
				hoverClass: "ui-state-active",
				cursor: "move",
				start: function(event,ui) {
				},
				stop: function(event,ui) {
					$(this).remove();
				}
			});
			
			$( ".col-content-group" ).droppable({
        accept: "#pane-moving",
        greedy: true,
        over: function(event, ui) {
					target = $( this ).parents(".col");
					if (target != origin) {
            $(this).addClass('highlight');
					}
        },
        out: function(event, ui) {
					target = $( this ).parents(".col");
					if (target != origin) {
            $(this).removeClass('highlight');
					}
        },
				drop: function( event, ui ) {
					var me = $(this);
					target = $( this ).parents(".col");
					var colid = target.attr("data-colid");
					
					$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'move_pane_content',sid:SB.sid, id:SB.paneid,colid:colid}, function(response){
						if (response.code == 1) {
							obj.detach();
              me.removeClass('highlight').append(obj);
							target = null;
						}
					});
				}
			});
		}
		
		function _delete(e, this_) {
			e.preventDefault();
			var obj = $(this_).parents('.pane-content');
			SB.colid = obj.attr('data-colid');
			SB.paneid = obj.attr('id');
			if (confirm("Do you really want to delete? This can not undone.")) {
				$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'delete_pane_content',sid:SB.sid, id:SB.paneid}, function(response){
					if (response.code == 1) {
						obj.remove();
					}
				});
			} else {
				return false;
			}
		}
		
		function _add_row(e, this_) {
			e.preventDefault();
			var secid = $(this_).parents('.wf-iconbar').attr("data-target");
			
			if (secid) {
				var top = $(window).height()/2-40;
				var lf = $(window).width()/2-200;
				$('#row-editor').find('.title').html("Add row to "+secid);
				$('#row-editor').css({position:"absolute", "top":top,"left":lf}).show();
				$('#row-editor').find('input[name=sectionid]').val(secid);
				$('#row-editor').find('input[name=sid]').val(SB.sid);
				$('#row-editor').find('input[name=layout]').val(SB.layout);
				
				$('.row-preset').click(function(){
					var rowconfig = $(this).attr("data-preset");
				  $('#row-editor').find('input[name=rowconfig]').val(rowconfig);
					$('#form-add-row').submit();
				});
				
				$('.close-row-editor').click(function(){
					var rowconfig = $(this).attr("data-preset");
				  $('#row-editor').find('input[name=sectionid]').val(0);
				  $('#row-editor').removeAttr('style').hide();
				});
			}
		}
		
		function _delete_row(e, this_) {
			e.preventDefault();
			var rid = $(this_).parents('.wf-iconbar').attr("data-target");
			var ty = $(this_).parents('.wf-iconbar').attr("data-type");
			
			if (rid) {
				if (confirm("Do you really want to delete this row? This can not undone.")) {
					$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'delete_row',sid:SB.sid, layout:SB.layout, gridid:rid}, function(response){
						if (response.code == 1) {
							$('#row-'+rid).remove();
						} else {
							alert(response.msg);
						}
					});
				} else {
					return false;
				}
			}
		}
		
		function _delete_col(e, this_) {
			e.preventDefault();
			var obj = $(this_).parents('.col');
			var colid = obj.attr('data-colid');
			var paneid = obj.attr('id');
			
			if (colid) {
				if (confirm("Do you really want to delete this column? This can not undone.")) {
					$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'delete_col',sid:SB.sid, layout:SB.layout, colid:colid}, function(response){
	/*					if (response.code == 1) {
							$('#' + paneid).parent('.row').html(response.update);
						} else {
							alert(response.msg);
						}*/
					});
				} else {
					return false;
				}
			}
		}
		
		function _add(e, this_) {
			e.preventDefault();
			var obj = $(this_).parents('.col');
			SB.colid = obj.attr('data-colid');
			SB.paneid = obj.attr('id');
			
			$("body").delegate(".pane-item","click",function(e) {
			  e.preventDefault();
				_Select(e, this, 0);
			});
			$('#modalOption').clone().attr("id", "elelist").dialog({
				width: $(window).width() -20,
				height: $(window).height() -20,
				title: 'Add element to Column '+SB.colid,
				modal:true,
				stack: true,
				create: function(event, ui) {
				  $("body").css({ overflow: 'hidden' })
				},
				beforeClose: function(event, ui) {
				  $("body").css({ overflow: 'inherit' })
				}
			});
		};
		

		function _delete_column(e, this_) {
			e.preventDefault();
			var id = $(this_).parent().attr('data-target');
			console.log(id);
			//$.post();
		}
		
		function _style_column(e, this_) {
			e.preventDefault();
			var target = $(this_).parent().attr('data-target');
			
			$('<div id="style-editor"></div>').appendTo('body').dialog({
				width: $(window).width()*0.9,
				height: $(window).height()*0.85,
				title: 'Column '+SB.target+' Styling',
				modal:true,
				stack: true
			});
		}
		
		var insertImage = function () {
			curImageDiv.find("i.fa").hide();
			curImageDiv.find("span").html('<img src="'+WF.baseUrl+selectedImage+'" with="200" />');
			var filename;
			if (selectedImage.indexOf("/") != -1)
			  filename = selectedImage.substring(selectedImage.lastIndexOf("/")+1);
			else
			  filename = selectedImage;
			curImageDiv.find("input").val(filename);
			curImageDiv.unbind("click");
			MM.dialog("close");
		};
		
		var selectImage = function (classname) {
      $("."+classname).click(function() {
				$('.selected-attachment').each(function(){
					$(this).removeClass('selected-attachment');
				});
				
				$(this).addClass('selected-attachment');
				selectedImage = $(this).find("img").attr("data");
      });	
      $(document).on("dblclick", "."+classname, function(){
				 $(this).trigger( "click" );
				 insertImage();
		 });
		};
		
    var init_item = function () {
      $("#group_elements").on( "click", ".element-edit", function() {
        var inner = $(this).parents('.li-element').find('.subitem');
        if (inner.is(":visible")) {
          inner.hide();
        }	else {
          inner.show();
        }
				return false;
      });
			
      $("#group_elements").on( "click", ".element-delete", function() {
        var itemId = $(this).parent().attr('data-target');
        var ptId = $(this).parent().attr('data-type');
				var this_ = $(this);
				console.log(itemId);
        if (itemId == 0) {
					$(this_).parents('.li-element').remove();
				} else {
					$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'delete_pane_item',sid:SB.sid,ptid:SB.ptId,id:itemId}, function(json){
						if (json.code) {
							$(this_).parents('.li-element').remove();
						} else {
							alert("Could not remove");
						}
					});
				}
				return false;
      });			
			
				
      $("#group_elements").on( "click", '.open-media-manager', function() {
        curImageDiv = $(this);						
        MM.load(WF.siteUrl+"admin/media_manager/"+SB.sid, function(){
					selectImage('media-thumb');
					$('#media-button-insert').click(function(){
						insertImage();						
					});
					
          var myDropzone = new Dropzone("form#uploader",{acceptedFiles: "image/*"});
 
          myDropzone.on("success", function(file, response){
            if (response.code == 1) {
              $('.media-button-insert').removeAttr("disabled");	
              selectedImage = response.file;
							$('.dz-image-preview').addClass('selected-attachment').find("img").attr("data", response.file);
            }
          });

          $(this).dialog({
            width: $(window).width(),
            height: $(window).height(),
            title: 'Media Manager',
            modal:true
          });
        });
				
				return false;
      });
    };
    
		function getPaneType(ptid) {
			for (var i = 0; i< WF.paneType.length; i++) {
				if (parseInt(WF.paneType[i].id) == ptid) {
					return WF.paneType[i];
				}
			}
			return false;
		}
		
		var addItem = function (id) {
			$.post(WF.siteUrl+'admin/'+WF.actionUrl+'/'+WF.site, {form_id:'get_new_item',sid:SB.sid,ptid:id}, function(html){
				$('#group_elements').append(html);
			});
		};
		
		function _Select(e, this_, id) {
			e.preventDefault();
			SB.ptId = parseInt($(this_).attr('pane-type'));
			
			var paneType = getPaneType(SB.ptId);
				// console.log(paneType);
			if (typeof paneType === 'object' && parseInt(paneType.req_setting) == 1) {
				active_element = SB.ptId;
				
				$.post(WF.siteUrl+'admin/'+WF.actionUrl, {form_id:'get_setting_form', el:SB.ptId, id:id, sid:SB.sid},function(response){
					$("#item-config").html(response.form);
					$('#elelist').dialog('destroy').remove();

				}).done(function() {
					$('#widget-form input[name=sid]').val(SB.sid);
					$('#widget-form input[name=colid]').val(SB.colid);
					$('#widget-form input[name=ptid]').val(SB.ptId);
					$('#widget-form input[name=layout]').val(SB.layout);
					$('.icp-auto').iconpicker();
					$('.preview-widget').click(function(e){
						$('#form_id').val("update_preview");
						$('form[name=wf-setting-form]').attr({target:'wf_preview_iframe', action: WF.siteUrl + "admin/layoutpreview"}).submit();
					});
					
					$('.save-widget').click(function(e){
						// e.preventDefault();
						$('#form_id').val("save_widget");
						$('form[name=wf-setting-form]').attr({action: WF.siteUrl + "admin/"+WF.actionUrl}).removeAttr("target").submit();
					});
					
					$(".jsn-add-more").click(function(e){
						// console.log(SB.ptId);
						addItem(SB.ptId);
					});
          
					$('.wf-tabs').tabs();
          $( "#group_elements" ).sortable({
            handle: ".element-drag"
          });
          $( "#group_elements").on( "sortupdate", function( event, ui ) {
            $('li.li-element').each(function() {
              var i = $(this).index();
              var inner = $('li.li-element').eq(i).find('.heading');
              $('li.li-element').eq(i).find('input.weight').val(i);
            });
          });
          init_item();
					
					var modal_height = $(window).height();
					$('#wf_preview_iframe').height(modal_height - 183);
					$("#item-config").dialog({
						width: $(window).width(),
						height: modal_height,
						title:'Column Settings',
						modal:true,
						stack: true,
						create: function(event, ui) {
							$("body").css({ overflow: 'hidden' })
						},
						beforeClose: function(event, ui) {
							$("body").css({ overflow: 'inherit' })
						}
					});
				});
			} else if (typeof paneType === 'object' && parseInt(paneType.req_setting) == 0) {
				$("<form method='post' action='' id='widget-form'></form>").appendTo('body');
				$("<input type='hidden' name='sid'/>").appendTo('#widget-form').val(SB.sid);
				$("<input type='hidden' name='colid'/>").appendTo('#widget-form').val(SB.colid);;
				$("<input type='hidden' name='ptid'/>").appendTo('#widget-form').val(SB.ptId);
				$("<input type='hidden' name='layout'/>").appendTo('#widget-form').val(SB.layout);
				$("<input type='hidden' name='nosetting'/>").appendTo('#widget-form').val(1);
				$("<input type='hidden' name='form_id'/>").appendTo('#widget-form').val('save_widget');
				$('#widget-form').submit();
			}
		}
	};
  
	$.HandleElement.resetModalSize = function (has_submodal, _return) {
		var modal_width, modal_height;

		if ( has_submodal == 0 ){
			modal_width  = $(window).width() * 0.9;
			var height   = $(window.parent).height() * 0.8;
			modal_height = ( height > 720 ) ? 720 : height;
		} else {
			var width    = parent.document.body.clientWidth * 0.9;
			modal_width  = (width > 750) ? 750 : width;
			var height   = parent.document.body.clientHeight*0.8;
			modal_height = ( height > 720 ) ? 720 : height;
		}
		if (_return == 'w'){
			return modal_width;
		} else {
			return modal_height;
		}
	};

	// Init WR PageSB element
	$.HandleElement.init = function(options) {
    var o = $.extend(defaults, options);
		$.HandleElement.addElement();
	};

	$(document).ready($.HandleElement.init);
})(jQuery);
