<?php
require_once ('core/config.php');


if (!isset($_SESSION['logistics']['logged_in']) || !isset($_SESSION['logistics']['username']) || !isset($_SESSION['logistics']['password'])) {
    
    // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
    header("location: login.php");
    exit;
} else {    
    $user_data = $User->is_login_valid($_SESSION['logistics']['username'], $_SESSION['logistics']['password']);    
    if ($user_data === false) {
        // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
        header("location: login.php");
        exit;
    }
}

$user_id        = $user_data['user_id'];


$country_codes_data = "";
$ban_ip_data = "";

$allowed_country_filepath = 'core/geoplugin_data/allowed_country.txt';
$ban_ip_filepath = 'core/geoplugin_data/ban_ip.txt';




// SAVE SUPPORTED/ALLOWED COUNTRY
if (isset($_POST['submit']) && $_POST['submit'] == 'SAVE-COUNTRY' && $CSRF->check_valid('post')) {
    
    $country_codes     = trim($_POST['country_codes']);
    
    if (file_exists($allowed_country_filepath)) {      
        
        chmod($allowed_country_filepath, 0755);
            
        //update the data
        $allowed_country_handle = fopen($allowed_country_filepath, 'w');
        fwrite($allowed_country_handle, $country_codes);
        fclose($allowed_country_handle);
        clearstatcache();
        $error = false;
        echo "<script type='text/javascript'> alert('Supported countries saved successfully.'); </script>";
                        
    } else {                   
        $error = true;
        echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
    }              
}


// SAVE BAN IP
if (isset($_POST['submit']) && $_POST['submit'] == 'SAVE-IP' && $CSRF->check_valid('post')) {
    
    $ban_ip     = trim($_POST['ban_ip']);
    
    if (file_exists($ban_ip_filepath)) {      
        
        chmod($ban_ip_filepath, 0755);
            
        //update the data
        $ban_ip_handle = fopen($ban_ip_filepath, 'w');
        fwrite($ban_ip_handle, $ban_ip);
        fclose($ban_ip_handle);
        clearstatcache();
        $error = false;
        echo "<script type='text/javascript'> alert('Banned IP saved successfully.'); </script>";
                        
    } else {                   
        $error = true;
        echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
    }              
}



//Fetch allowed countries  file data
if (file_exists($allowed_country_filepath)) {    
    $allowed_country_handle = fopen($allowed_country_filepath, 'r');
    
    $country_codes_data = @fread($allowed_country_handle, filesize($allowed_country_filepath));  
    
    fclose($allowed_country_handle);    
    clearstatcache();
}

//Fetch ban IP file data
if (file_exists($ban_ip_filepath)) {    
    $ban_ip_handle = fopen($ban_ip_filepath, 'r');
    
    $ban_ip_data = @fread($ban_ip_handle, filesize($ban_ip_filepath)); 
     
    fclose($ban_ip_handle);    
    clearstatcache();
}


?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <meta name="robots" content="index" />
    <meta name="googlebot" content="index" />
    <meta name="robots" content="follow" />
    <meta name="robots" content="nocache" /> 
    <meta http-equiv="cache-control" content="no-cache" />                       
	<meta http-equiv="expires" content="-1" />
    
    <base href="" />
    
    <title>Dashboard | <?php echo $config['app_name'];?></title>


    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet" />

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>
  <body>
  
    <div id="header">
        <?php require_once ('_header.php'); ?>  
    </div>
    
    <div id="content" class="container">
        
        <div class="row">
            <?php require_once ('_main_top.php'); ?>          
        </div>
        
        <div class="row">
            <div class="col-md-2" id="sidebar">
                <?php require_once ('_sidebar.php'); ?>
            </div>
            
            
            <div class="col-md-10">
                
                    <h3 class="page_label">Supported Countries</h3>
                    <hr />          
                    <div class="help-block" style="color: red;">
                        Enter a comma (<strong>,</strong>) separated list of 2-characters ISO-2 codes of countries where users/clients 
                        are allowed to view this site from. <br>
						For example: <br>
						<strong>GB, US, MY</strong> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <i>--- Site will open in United Kingdom, United States and Malaysia.</i> <br />
						<strong>NG, CA, FI</strong> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <i>--- Site will open in Nigeria, Canada and Finland.</i> <br />
                        
						<br>
						You can allow access from all countries by entering asterik (<strong>*</strong>) to the list. <br />
						For example: <br>
						<strong>*</strong> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <i>--- Site will open in all countries.</i> <br />
						<strong>GB, US, *</strong> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <i>---  Site will open in United Kingdom, United States and also in all countries because of the asterik (<strong>*</strong>).</i> <br />
						
                        <span><a href="http://www.nationsonline.org/oneworld/country_code_list.htm" target="_blank" style="color:blue;">See List of Country ISO-2 Codes</a></span>
                    </div>
                    
                    <form class="form-horizontal" method="post" action="" onsubmit="return confirm('CONFIRMATION: \n\n Are you sure you want to save this?');">
                        <?php $CSRF->echo_token_input_field(); ?>
                        <div class="form-group">
                            <label for="country_codes" class="col-sm-12 control-label" style="text-align: left;">Country ISO-2 Codes: </label>
                            <div class="col-sm-12">
                              <textarea class="form-control input-lg" rows="5" id="country_codes" name="country_codes" placeholder="Country ISO Codes"><?php echo ($error === true && isset($_POST['country_codes'])) ? trim($_POST['country_codes']) : trim($country_codes_data); ?></textarea>
                            </div>
                        </div>  
                        <div class="form-group">
                            <div class="col-sm-7" style="text-align: left;">
                              <button type="submit" id="submit" name="submit" value="SAVE-COUNTRY" class="btn btn-primary btn-lg submit_btn">SAVE</button>
                            </div>
                        </div>
                    </form>      
                    
                    <hr class="" />      
                    
                    
                    <h3 class="page_label">Ban IP</h3>
                    <hr />          
                    <div class="help-block" style="color: red;">
                        Enter a comma (<strong>,</strong>) separated list of IPs you want to ban from accessing this site. 
                        E.g: <strong>105.211.32.47, 105.211.32.47, 105.211.32.*, 105.211.*.*</strong> <br />
                        Where asterik (<strong>*</strong>) is used to indicate IP range. 
                        
                    </div>
                    
                    <form class="form-horizontal" method="post" action="" onsubmit="return confirm('CONFIRMATION: \n\n Are you sure you want to save this?');">
                        <?php $CSRF->echo_token_input_field(); ?>
                        <div class="form-group">
                            <label for="ban_ip" class="col-sm-12 control-label" style="text-align: left;">IPs: </label>
                            <div class="col-sm-12">
                              <textarea class="form-control input-lg" rows="5" id="ban_ip" name="ban_ip" placeholder="Ban IPs"><?php echo ($error === true && isset($_POST['ban_ip'])) ? trim($_POST['ban_ip']) : trim($ban_ip_data); ?></textarea>
                            </div>
                        </div>  
                        <div class="form-group">
                            <div class="col-sm-7" style="text-align: left;">
                              <button type="submit" id="submit" name="submit" value="SAVE-IP" class="btn btn-primary btn-lg submit_btn">SAVE</button>
                            </div>
                        </div>
                    </form>         
                    
                    
            </div>
        </div>
    </div>

    <div id="footer">
        <?php require_once ('_footer.php'); ?>
    </div>



    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script type="text/javascript" src="js/jquery.js"></script>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script type="text/javascript" src="js/bootstrap.min.js"></script>  
    <script type="text/javascript" src="js/script.js"></script>    
  </body>
</html>