<?php
require_once ('core/config.php');
require_once ('core/db_backup_cron.php');

if (!isset($_SESSION['logistics']['logged_in']) || !isset($_SESSION['logistics']['username']) || !isset($_SESSION['logistics']['password'])) {
    
    // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
    header("location: login.php");
    exit;
} else {    
    $user_data = $User->is_login_valid($_SESSION['logistics']['username'], $_SESSION['logistics']['password']);    
    if ($user_data === false) {
        // echo "<script type='text/javascript'> alert('Your session has expired.'); </script>";
        header("location: login.php");
        exit;
    }
}

$user_id        = $user_data['user_id'];


// DELETE
if (isset($_GET['del']) && $Transaction->get_cargo($_GET['del']) !== false && $CSRF->check_valid('get')) {    
    
    if ($Transaction->delete_cargo($_GET['del']) === true) {    
        echo "<script type='text/javascript'> alert('Shipment/Cargo deleted successfully.'); </script>";  
		echo '<meta http-equiv="refresh" content="0; url=index.php" />';
		echo '<script type="text/javascript"> window.top.location = "index.php"; </script>';            
		exit;
    } else {                
            
        echo "<script type='text/javascript'> alert('Unable to perform request at the moment. Please try again or contact webmaster.'); </script>";
    }    
}



// Get all Cargoes records
if ($_SESSION['logistics']['username'] == 'admin') {
    $cargoes = $Transaction->get_cargoes();
} else {
    $cargoes = $Transaction->get_cargoes($user_id);
}




?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <meta name="robots" content="index" />
    <meta name="googlebot" content="index" />
    <meta name="robots" content="follow" />
    <meta name="robots" content="nocache" /> 
    <meta http-equiv="cache-control" content="no-cache" />                       
	<meta http-equiv="expires" content="-1" />
    
    <base href="" />
    
    <title>Dashboard | <?php echo $config['app_name'];?></title>


    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet" />

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>
  <body>
  
    <div id="header">
        <?php require_once ('_header.php'); ?>  
    </div>
    
    <div id="content" class="container">
        
        <div class="row">
            <?php require_once ('_main_top.php'); ?>          
        </div>
        
        <div class="row">
            <div class="col-md-2" id="sidebar">
                <?php require_once ('_sidebar.php'); ?>
            </div>
            
            
            <div class="col-md-10">
			
					<h3 class="page_label">Dashboard / Shipment Records</h3>
                    <hr />          
					
                    * Click on the <strong>Tracking Number</strong> to see details and history of the shipment. <br /><br />
                    
                    <table class="table table-responsive table-striped table-bordered">
                        <thead>
                            <tr>
                                <th>S/N</th>  
                                <th>Tracking Number</th>                              
                                <th>Description</th>
                                <th>Sender</th>
                                <th>Receiver</th>
                                <th>Date</th>
                                <th>Status</th>
                                <th>[...]</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php 
                                if ($cargoes === false) {
                                    echo '<tr><td colspan="9">No shipment/cargo recorded<td></tr>';
                                } else { 
                                    $counter = 0;
                                    foreach ($cargoes as $cargo)
                                    {
                                        $d_user = $User->get_a_record_by_field('user_id', $cargo['user_id']);
                                        $username = (is_array($d_user))? $d_user['username'] : 'UNKNOWN';

                                        $counter++;
                            ?>
                                                                        
                                        <tr>                                 
                                            <td><?php echo $counter;?></td>
                                            <td><strong><a href="cargo_history.php?user=<?php echo $username.'&cid='.$cargo['cargo_id']."&".$CSRF->get_token_url_qstring();?>"><?php echo $cargo['tracking_code']?></a></strong></td>
                                            <td><?php echo $cargo['description']?></td>
                                            <td>
												<b><?php echo $cargo['sender'];?></b> <br>
												<?php echo $cargo['origin'];?>
											</td>
                                            <td>
												<b><?php echo $cargo['receiver'];?></b><br>
												<?php echo $cargo['destination'];?><br>
												<?php echo $cargo['receiver_phone'];?><br>
												<?php echo $cargo['receiver_email'];?>
											</td>
                                            <td><?php echo $cargo['date_added'];?></td>
                                            <td>
												<?php 
													if ($cargo['status'] == "Shipment Held") {
														echo "<span style=\"color: red;\">" . $cargo['status'] . "</span>";
													} else {
														echo $cargo['status'];
													}												
												?>
											</td>
                                            <td>
                                                <a href="cargo_add.php?upd=<?php echo $cargo['cargo_id']."&".$CSRF->get_token_url_qstring();?>">Update</a> |
                                                <a href="index.php?del=<?php echo $cargo['cargo_id']."&".$CSRF->get_token_url_qstring();?>" onclick="return confirm('CONFIRMATION: \n\n Are you sure you want to DELETE shipment with Tracking Code: <?php echo $cargo['tracking_code']?>?');">Delete</a>
                                            </td>
                                        </tr>
                            <?php 
                                    }
                                }
                            ?>
                        </tbody>
                    </table> 
                    
            </div>
        </div>
    </div>

    <div id="footer">
        <?php require_once ('_footer.php'); ?>
    </div>



    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script type="text/javascript" src="js/jquery.js"></script>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script type="text/javascript" src="js/bootstrap.min.js"></script>  
    <script type="text/javascript" src="js/script.js"></script>  
  </body>
</html>