<?php
require_once ('core/config.php');


if (isset($_POST['submit']) && $_POST['submit'] == 'LOGIN' && $CSRF->check_valid('post')) {
    
    $username    = trim($_POST['username']);
    $password   = trim($_POST['password']);
    
    if (empty($username) || empty($password)) { 
        $error = true;
        echo "<script type='text/javascript'> alert('Please enter your Username and Password.'); </script>";
    } else {
    
        $user_data = $User->is_login_valid($username, $password, true);
        
        if ($user_data !== false) {
            
            $_SESSION['logistics']['logged_in']   = true;
            $_SESSION['logistics']['user_id']     = $user_data['user_id'];
            $_SESSION['logistics']['username']    = $user_data['username'];
            $_SESSION['logistics']['password']    = $user_data['password'];
                        
            header("location: index.php");
            exit;
                    
        } else {
    
            $error = true;
            echo "<script type='text/javascript'> alert('Invalid Username or Password.'); </script>";
        }  
    }      
}


?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <meta name="robots" content="index" />
    <meta name="googlebot" content="index" />
    <meta name="robots" content="follow" />
    <meta name="robots" content="nocache" /> 
    <meta http-equiv="cache-control" content="no-cache" />                       
	<meta http-equiv="expires" content="-1" />
    
    <base href="" />
    
    <title><?php echo $config['app_name'];?> Admin</title>


    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet" />

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>
  <body>
  
    <div id="header">
        <?php require_once ('_header.php'); ?>  
    </div>
    
    <div id="content" class="container">
        <div class="row">
          <div class="col-md-12">
            <h3 class="page_label">Log in to <?php echo $config['app_name'];?> Admin</h3>
            <hr />          
            
            <form class="form-horizontal" method="post" action="">
                <?php $CSRF->echo_token_input_field(); ?>
                <div class="form-group">
                    <label for="user_id" class="col-sm-1 control-label">Username:</label>
                    <div class="col-sm-4">
                      <input type="text" class="form-control" id="username" name="username" placeholder="Username" value="<?php if ($error === true && isset($_POST['username'])) { echo trim($_POST['username']);} ?>" required>
                    </div>
                </div>
                <div class="form-group">
                    <label for="passcode" class="col-sm-1 control-label">Password:</label>
                    <div class="col-sm-4">
                      <input type="password" class="form-control" id="password" name="password" placeholder="Password" value="" maxlength="50" required>
                    </div>
                </div>
                <div class="form-group">
                    <label for="passcode" class="col-sm-1 control-label"></label>
                    <div class="col-sm-4">
                      <button type="submit" id="submit" name="submit" value="LOGIN" class="btn btn-primary submit_btn">LOGIN</button>
                    </div>
                </div>
            </form>
                    
          </div>
          
        </div>
    </div>

    <div id="footer">
        <?php require_once ('_footer.php'); ?>  
    </div>


    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script type="text/javascript" src="js/jquery.js"></script>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script type="text/javascript" src="js/bootstrap.min.js"></script>    
    
  </body>
</html>